function [T, Y]=falling_sphere
 
g=9.81;     % Gravity=9.81 m/s^2 %
A=[0,1;0,0]; b=[0; -1]; u=g;
 
tspan=[0,1];    % t0=0, tf=1 sec %
y0=[0;0];       % s0=0, v0=0 %
options = odeset('RelTol',1e-4,'AbsTol',[1e-4 1e-4]);
[T,Y] = ode45(@(t,y) falling_stone(t, y, A, b, u),tspan,y0,options);
 
figure(1)
subplot(1,2,1), plot(T,Y(:,1));
xlabel('time [sec]'); ylabel('displacement [m]'); grid on;
subplot(1,2,2), plot(T,Y(:,2));
xlabel('time [sec]'); ylabel('velocity [m/sec]'); grid on;
 
function dy=falling_stone(t,y, A, b, u)
dy=A*y+b*u;
