%{
    Version Info
    Edited: 2010.01.20
%}

function varargout = menu_xy(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @menu_xy_OpeningFcn, ...
                   'gui_OutputFcn',  @menu_xy_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before menu_xy is made visible.
function menu_xy_OpeningFcn(hObject, eventdata, handles, varargin)
% Choose default command line output for menu_xy
handles.output = hObject;

%------------- (3) Timer Related %
handles.Ht_Display=timer;
delete(handles.Ht_Display);
% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = menu_xy_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;

%% (1) Start and Stop
function START_Callback(hObject, eventdata, handles)
%-- Step 1: Find Simulation or Target Object %
handles.tg=xpc;

max_ch=2;   % Maximum Channels %
handles.max_ch=max_ch;

%------------- Application Data %
data=getappdata(handles.output,'mydata');
data.Hv_vrml=vrworld('XY-Move.wrl');
setappdata(handles.output,'mydata',data);      % Saving Data %
open(data.Hv_vrml);
view(data.Hv_vrml);

%-- Step 4: Start Simulation or Control %
if ~isvalid(handles.Ht_Display)
    handles.Ht_Display=timer('ExecutionMode','fixedRate', ...
            'TasksToExecute',10000000, ... 
            'Period', 0.1);
    set(handles.Ht_Display, 'TimerFcn',{@Timer_Callback_Display, handles});
end
if isvalid(handles.Ht_Display)
    if strcmp(get(handles.Ht_Display, 'Running'), 'off'), start(handles.Ht_Display); end
end

+handles.tg;

% Update handles structure
guidata(hObject, handles);

function STOP_Callback(hObject, eventdata, handles)
-handles.tg;
if isvalid(handles.Ht_Display), stop(handles.Ht_Display); end
% Update handles structure
guidata(hObject, handles);

function LOAD_Callback(hObject, eventdata, handles)
load(xpc,handles.file_name);

function FILE_NAME_Callback(hObject, eventdata, handles)
handles.file_name=get(hObject,'String');
guidata(hObject, handles);

function FILE_NAME_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.file_name=get(hObject,'String');
guidata(hObject, handles);

function figure1_CloseRequestFcn(hObject, eventdata, handles)
%if isvalid(handles.Ht_Display), delete(handles.Ht_Display); end
delete(hObject);


%% (7) [Timer Callback]
% -----------(1) Display Timer Callback 
function Timer_Callback_Display(hObject, eventdata, handles)

persistent index flag_p;

if isempty(index), index=0; end
if isempty(flag_p), flag_p=0; end

% Time Display %
count=get(handles.Ht_Display, 'TasksExecuted');
set(handles.CSTATUS4, 'String', num2str(0.1*count, '%6.1f\n'));

%--- Displaying Desired Position Values --- %
signal_str_xpc='Sum1';
pos=get_signal_vector(handles, signal_str_xpc);

size_xd=size(pos);
if size_xd(1,1)==2
    set(handles.DPOS, 'String', num2str(pos, '%10.1f\n'));    
end
%------------- Application Data %
data=getappdata(handles.output,'mydata');
data.Hv_vrml.dad_Point1.translation=[pos(1,1), 0, -pos(2,1)];
setappdata(handles.output,'mydata',data);      % Saving Data %

% -----------(5) End of Timer Callback 

%%  [Get & Set Functions]
function set_parameter(handles, param_str, value)
handles.tg.setparam(handles.tg.getparamid(param_str, 'Value'), value);

function [value] = get_signal(handles, signal_str_xpc)
value=handles.tg.getsignal(handles.tg.getsignalid(signal_str_xpc));

function [out]=get_signal_vector(handles, signal_str_xpc)
if handles.max_ch==2,
    out(1,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s1')));
    out(2,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s2')));
end
if handles.max_ch==3,
    out(1,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s1')));
    out(2,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s2')));
    out(3,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s3')));
end
if handles.max_ch==4,
    out(1,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s1')));
    out(2,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s2')));
    out(3,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s3')));
    out(4,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s4')));    
end

function [out]=get_signal_matrix(handles, signal_str_xpc)
    if handles.max_ch==2,
        out(1,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s1')));
        out(2,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s2')));
        out(1,2)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s3')));
        out(2,2)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s4')));
        out(1,3)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s5')));
        out(2,3)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s6')));
    end
    if handles.max_ch==4,
        out(1,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s1')));
        out(2,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s2')));
        out(3,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s3')));
        out(4,1)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s4')));
        out(1,2)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s5')));
        out(2,2)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s6')));        
        out(3,2)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s7')));
        out(4,2)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s8')));
        out(1,3)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s9')));
        out(2,3)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s10')));        
        out(3,3)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s11')));
        out(4,3)=handles.tg.getsignal(handles.tg.getsignalid(strcat(signal_str_xpc,'/s12')));        
    end    

